// HyperMD, copyright (c) by laobubu
// Distributed under an MIT license: http://laobubu.net/HyperMD/LICENSE
//
// POWERPACK for "addon/fold-emoji"
//
// Use emoji-toolkit to lookup emojis and render emoji `:smile:` :smile:
//
// :warning: **License**:
//
// Please follow https://joypixels.com/licenses/free if you use this powerpack.
// 使用前請注意閱讀 emoji-toolkit 使用許可
//
define(["require", "exports", "emoji-toolkit", "../addon/fold-emoji", "emoji-toolkit/extras/css/joypixels.min.css"], function (require, exports, _emoji_toolkit_module, fold_emoji_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.emojiToolkitRenderer = exports.emojiToolkitChecker = void 0;
    /** emojiToolkit doesn't have AMD declaration. load it from browser if needed */
    var emojiToolkit = _emoji_toolkit_module || this['emoji-toolkit'] || window['joypixels'];
    var emojiToolkitChecker = function (text) { return emojiToolkit.shortnameToUnicode(text) != text; };
    exports.emojiToolkitChecker = emojiToolkitChecker;
    var emojiToolkitRenderer = function (text) {
        var html = emojiToolkit.shortnameToImage(text);
        if (!/^<img /i.test(html))
            return null;
        var attr = /([\w-]+)="(.+?)"/g;
        var ans = document.createElement("img");
        var t;
        while (t = attr.exec(html))
            ans.setAttribute(t[1], t[2]);
        return ans;
    };
    exports.emojiToolkitRenderer = emojiToolkitRenderer;
    // Update default EmojiChecker and EmojiRenderer
    if (emojiToolkit) {
        fold_emoji_1.defaultOption.emojiChecker = exports.emojiToolkitChecker;
        fold_emoji_1.defaultOption.emojiRenderer = exports.emojiToolkitRenderer;
    }
    else {
        console.error("[HyperMD] PowerPack fold-emoji-with-emoji-toolkit loaded, but emoji-toolkit not found.");
    }
});
